/*
  Name: main.cpp
  Copyright: -
  Author: Graillot Romain
  Date: 21/04/07 00:20
  Description: invitro officiel pour les Infoticaires 2007
*/
#include "main.h"

vector<TrueColorPixel> buffer  ( WIDTH * HEIGHT );   // Un buffer pour l'affichage
DisplayListener listener;  // Et un listener ? pour terminer l'application quand on ferme la fentre
int pages_totales = 11;
int lignes_totales = pages_totales*9;
int page_actuelle = 0;
int y_base = -153;
bool affiche = true;
double delay = 3;
double counter;
// { = "'"
// | ="-"
// } = " "
// ~ = "."
const char *messages[ ] =
    {"||}infoticaires}||",
     "invitro",
     "",
     "les}infoticaires",
     "c{est}le",
     "rassemblement",
     "des}fous}de",
     "vieux}ordis}et",
     "consoles}de}l{ete", // fin page 1

     "c{est}a}courcelles",
     "que}sa}ce}passe~",
     "",
     "petit}village}dans",
     "la}nievre}reposant",
     "entre}nevers",
     "et}auxerre~~~",
     "",
     "", // fin page 2

     "voici}un}petit",
     "apercu}des",
     "festivites",
     "",
     "le}lancer}de}veaux",
     "n{est}pas}autorise",
     "malgre}la}demande",
     "",
     "desole", // fin page 3

     "concours}de}peche",
     "sur}dreamcast",
     "",
     "pucage|switchage",
     "de}consoles",
     "",
     "demontage}de",
     "machines",
     "", // fin page 4

     "de}quoi}jouer",
     "a}tout}va",
     "",
     "tournoi",
     "retro|gaming",
     "avec}des}lots}a",
     "gagner",
     "",
     "puces",  // fin page 5

     "concours}de",
     "{tunning{}sur",
     "vieilles}machines",
     "",
     "projection",
     "d{emmission}sur",
     "les}jeux}video",
     "|sa}date}un}peu|",
     "",  // fin de la page 6

     "apero}quand}on",
     "veut}}}|ouaaii|",
     "",
     "et}bien}sur",
     "comme}chaques",
     "annee}on}garde",
     "un}peu}de}marge",
     "pour}faire}ce",
     "que}l{on}veut", // fin 7

     "alors}si}vous",
     "avez}des}idees",
     "enmenez}les}avec",
     "vous~~~",
     "",
     "tant}que}c{est",
     "fun}et}debile",
     "on}vous}suis",
     "",  // fin de la page 8

     "pour}plus}de",
     "details}surtout",
     "en}ce}qui}concerne",
     "les}reservations",
     "l{hebergement",
     "etc~~~",
     "",
     "",
     "obsolete|tears~com",  // fin de la page 9

     "bon}sinon}il}n{y",
     "a}pas}de}messages",
     "sublminaux}dans",
     "ce}programmme~~~",
     "zenev}xuerbmon",
     "ce}n{est}pas}notre",
     "genre}alors}soyez",
     "tranquil",
     "ut}tse}enu}eluop",  // fin 10

     "invitro}codee}par",
     "romain",
     "www~romsoft~fr~nf",
     "",
     "chipmunk~mod}de",
     "jester}of}sanity",
     "",
     "lib}ufmod}et",
     "pixeltoaster" // fin page 11
    };
// ou on en est ?
enum scene{ sc_presentation,
            sc_invtro,
          };

// Dfinition de la structure star
struct star
{
    int x; // position x
    int y; // position y
    int z; // position z (pour la vitesse et la couleur)
};
star starfield[MAX_STARS]; // un tableau de star

int Scene = sc_presentation;

int  col = 0;  // pour gr la couleur de certain pixel
int theta = 0;  // un compteur qui va nous servir a plein de chose :)

// Calcule de variable pour le centrage des images
int img_date_centre = (WIDTH/2)-(img_date_WIDTH/2); // pour centrer le logo img_date
int infoticaires_centre = (WIDTH/2) - (infoticaires_WIDTH/2);
int projet_centre_x = (WIDTH/2) - (projet_WIDTH/2);
int projet_centre_y = (HEIGHT/2) - (projet_HEIGHT/2);

float SinTab[359];
float CosTab[359];


// fonction putpixel
// pose un pixel au cordonner x,y et de couleur coul
int putpixel(int x,int y, unsigned int col)
{
    buffer[(y*WIDTH)+x].integer = col;
};

// { = "'"
// | ="-"
// } = " "
// ~ = "."
int puttext(int x,int y,const char *txt, ...)
{

    char  text[256];
    va_list  ap;

    va_start(ap, txt);
    vsprintf(text, txt, ap);
    va_end(ap);

    for (int loop=0;loop<(strlen(text));loop++)
    {
        unsigned int chpos = (unsigned int) (text[loop]-97)*17;
        for(int yy=0; yy<17; ++yy)
        {
            for(int xx=0; xx<17; ++xx)
            {
                int py = y+(yy+int(SinTab[(int(theta*0.6)+y+x) % 359]*15));
                int px = x+(xx+int(CosTab[(int(theta*0.6)+x+y+y) % 359]*8));
                if(py < 29)
                    continue;
                if(py>HEIGHT-31)
                    continue;

                col = police[(yy*police_WIDTH)+(chpos+xx)];
                if(col!=0)
                    putpixel(px,py,buffer[(py*WIDTH)+px].integer | col); // alpha blending rulez :) (j'ai trouv sa par hasard...)
            }
        }
        x += 17;
    }

};

int main()
{

    Display display;
    display.listener(&listener);
    // gestion plein cran / fentre
    if( MessageBox(NULL,"Plein cran 320x240 ?\n\nLe mode \"Plein cran\" est conseill","Affichage",MB_YESNO | MB_ICONINFORMATION) == IDNO)
    {
        display.open( "Invitro", WIDTH, HEIGHT, Output::Windowed, Mode::TrueColor );
    }
    else
    {
        display.open( "Invitro", WIDTH, HEIGHT, Output::Fullscreen, Mode::TrueColor );
    };

    // Initialisation du tableau de sinus et de cosinus
    for(int i=0; i<359; i++)
    {
        CosTab[i] = cos(i*M_PI/180);
        SinTab[i] = sin(i*M_PI/180);
    }

    // initialisation des toiles
    for(int i=0; i<MAX_STARS; ++i)
    {
        starfield[i].x = (rand() % WIDTH);
        starfield[i].y = (rand() % (HEIGHT-60))+30;
        starfield[i].z = (rand() % 3)+1;
    }

    Timer timer;
    counter = timer.time();

    // tant que la fentre est ouverte ou execute le code d'animation
    while ( display.open() )
    {
        switch(Scene)
        {
            case sc_presentation:
            for(int y=0;y<HEIGHT;++y)
            {
                for(int x=0; x<WIDTH; ++x)
                {
                    col = rand() % 255;
                    putpixel(x,y,col<<16 | col<<8 | col);
                }
            }
            for(int y=0;y<projet_HEIGHT;++y)
            {
                for(int x=0; x<projet_WIDTH; ++x)
                {
                    col = projet[(y*projet_WIDTH)+x];
                    if (col != 0)
                        putpixel(projet_centre_x+x,projet_centre_y+y,projet[(y*projet_WIDTH)+x] | buffer[((projet_centre_y+y)*WIDTH)+projet_centre_x+x].integer);
                }
            }
            if((timer.time()-counter) > delay)
            {
                Scene = sc_invtro;
                for(int y=0; y<HEIGHT; ++y)
                    for(int x=0; x<WIDTH; ++x)
                        putpixel(x,y,0);
                counter = timer.time();
                delay = 5;
                uFMOD_PlaySong(xm,(void*)sizeof(xm),XM_MEMORY);
            }
            break;


            case sc_invtro:

			// Efface l'ecran a partir de y=29 jusque a y=181
            memset(&buffer[29*320],0, 181*WIDTH*4);

            // le mode "16/9" avec un trait multicolor
            for(int x=0; x<WIDTH; ++x)
            {
                col = abs(int(CosTab[(x+theta)%359]*255))<<16 | abs(int(SinTab[(x+theta<<4)%359]*255))<<8 | abs(int(CosTab[(x+theta>>8)%359]*255));
                putpixel(x,28,col);
                putpixel((WIDTH-1)-x,HEIGHT-30,col);
            }

            // puis les 2 logos
            for (int y =0; y<img_date_HEIGHT; ++y)
            {
                for(int x=0; x<img_date_WIDTH; ++x)
                {
                    col = img_date[(y*img_date_WIDTH)+x];
                    putpixel(img_date_centre+int(x+SinTab[(theta+x+y) % 360]*25),(HEIGHT-img_date_HEIGHT-2)+y,col);
                }
            }
            for (int y =0; y<infoticaires_HEIGHT; ++y)
            {
                for(int x=0; x<infoticaires_WIDTH; ++x)
                {
                    col = infoticaires[(y*infoticaires_WIDTH)+x];
                    putpixel(infoticaires_centre+int(x+SinTab[((theta-180)+x+y) % 360]*20),y+1,col);
                }
            }

            // affichage et dplacement des toiles
            for(int i = 0; i<MAX_STARS; ++i)
            {
                // bouge l'toile
                starfield[i].x -= starfield[i].z;
                // et l'affiche dans le buffer
                col = starfield[i].z*85;
                putpixel(starfield[i].x % WIDTH-1,starfield[i].y,col<<16 | col<<8 | col);
            }


            if(affiche == TRUE)
                if(y_base < 42)
                    y_base+=3;

            if(affiche == FALSE)
                if(y_base > -153)
                    y_base-=3;

            for(int i=0;i<9;++i)
            {
                int posx = (WIDTH/2) - ((strlen(messages[(page_actuelle*9)+i])*17)/2);
                puttext(posx,y_base+(i*17),messages[(page_actuelle*9)+i]);
            };

            if((timer.time()-counter) > delay)
            {
                if(affiche == FALSE)
                {
                    page_actuelle += 1;
                    if (page_actuelle == pages_totales)
                    {
                        page_actuelle=0;
                    }
                    delay = 10;
                }
                else
                {
                    delay = 2;
                }
                affiche = not affiche;
                counter = timer.time();
            }

            break;
        } // switch
        theta += 2;

        // "pose" notre buffer dans la fentre
        display.update( buffer );

    } // while
    uFMOD_StopSong();
    return 0;
} // main

